Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 3211)
@@ -42,4 +42,15 @@
 
    REAL(wp) ::  r_vvl     ! variable volume indicator, =1 if lk_vvl=T, =0 otherwise 
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+#  include "traldf_iso_grif_ftrans.h90"
 
    !! * Substitutions
@@ -77,4 +88,8 @@
       USE oce     , ONLY:   zwd => ua       , zws => va         ! (ua,va) used as 3D workspace
       USE wrk_nemo, ONLY:   zwi => wrk_3d_6 , zwt => wrk_3d_7   ! 3D workspace 
+
+      !! DCSE_NEMO: Need additional directives for renamed module variables
+!FTRANS zwd zws :I :I :z
+!FTRANS zwi zwt :I :I :z
       !
       INTEGER                              , INTENT(in   ) ::   kt       ! ocean time-step index
@@ -82,6 +97,12 @@
       INTEGER                              , INTENT(in   ) ::   kjpt     ! number of tracers
       REAL(wp), DIMENSION(        jpk     ), INTENT(in   ) ::   p2dt     ! vertical profile of tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb      ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta      ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb      ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta      ! tracer trend 
+
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)      ! before and now tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)      ! tracer trend 
       !
       INTEGER  ::  ji, jj, jk, jn   ! dummy loop indices
@@ -115,15 +136,43 @@
             !
             ! vertical mixing coef.: avt for temperature, avs for salinity and passive tracers
+#if defined key_z_first
+            IF( cdtype == 'TRA' .AND. jn == jp_tem ) THEN
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zwt(ji,jj,1) = 0._wp
+                     DO jk = 2, jpk
+                        zwt(ji,jj,jk) = avt  (ji,jj,jk)
+                     END DO
+                  END DO
+               END DO
+            ELSE                                
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     zwt(ji,jj,1) = 0._wp
+                     DO jk = 2, jpk
+                        zwt(ji,jj,jk) = fsavs(ji,jj,jk)
+                     END DO
+                  END DO
+               END DO
+            ENDIF
+#else
             IF( cdtype == 'TRA' .AND. jn == jp_tem ) THEN   ;   zwt(:,:,2:jpk) = avt  (:,:,2:jpk)
             ELSE                                            ;   zwt(:,:,2:jpk) = fsavs(:,:,2:jpk)
             ENDIF
             zwt(:,:,1) = 0._wp
+#endif
             !
 #if defined key_ldfslp
             ! isoneutral diffusion: add the contribution 
             IF( ln_traldf_grif    ) THEN     ! Griffies isoneutral diff
+#if defined key_z_first
+               DO jj = 2, jpjm1
+                  DO ji = 2, jpim1
+                     DO jk = 2, jpkm1
+#else
                DO jk = 2, jpkm1
                   DO jj = 2, jpjm1
                      DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                         zwt(ji,jj,jk) = zwt(ji,jj,jk) + ah_wslp2(ji,jj,jk)       
                      END DO
@@ -131,7 +180,13 @@
                END DO
             ELSE IF( l_traldf_rot ) THEN     ! standard isoneutral diff
+#if defined key_z_first
+               DO jj = 2, jpjm1
+                  DO ji = 2, jpim1
+                     DO jk = 2, jpkm1
+#else
                DO jk = 2, jpkm1
                   DO jj = 2, jpjm1
                      DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                         zwt(ji,jj,jk) = zwt(ji,jj,jk) + fsahtw(ji,jj,jk)                       &
                            &                          * (  wslpi(ji,jj,jk) * wslpi(ji,jj,jk)   &
@@ -143,4 +198,15 @@
 #endif
             ! Diagonal, lower (i), upper (s)  (including the bottom boundary condition since avt is masked)
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * fse3t_a(ji,jj,jk)   ! after scale factor at T-point
+                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * fse3t_n(ji,jj,jk)   ! now   scale factor at T-point
+                     zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * fse3w(ji,jj,jk  ) )
+                     zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * fse3w(ji,jj,jk+1) )
+                     zwd(ji,jj,jk) = ze3ta - zwi(ji,jj,jk) - zws(ji,jj,jk)
+                 END DO
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
@@ -154,4 +220,5 @@
                END DO
             END DO
+#endif
             !
             !! Matrix inversion from the first level
@@ -176,4 +243,12 @@
             ! first recurrence:   Tk = Dk - Ik Sk-1 / Tk-1   (increasing k)
             ! done once for all passive tracers (so included in the IF instruction)
+#if defined key_z_first
+                  zwt(ji,jj,1) = zwd(ji,jj,1)
+                  DO jk = 2, jpkm1
+                    zwt(ji,jj,jk) = zwd(ji,jj,jk) - zwi(ji,jj,jk) * zws(ji,jj,jk-1) / zwt(ji,jj,jk-1)
+                  END DO
+               END DO
+            END DO
+#else
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -188,8 +263,22 @@
                END DO
             END DO
+#endif
             !
          END IF 
          !         
          ! second recurrence:    Zk = Yk - Ik / Tk-1  Zk-1
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b(ji,jj,1)
+               ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t(ji,jj,1)
+               pta(ji,jj,1,jn) = ze3tb * ptb(ji,jj,1,jn) + p2dt(1) * ze3tn * pta(ji,jj,1,jn)
+               DO jk = 2, jpkm1
+                  ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b(ji,jj,jk)
+                  ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t  (ji,jj,jk)
+                  zrhs = ze3tb * ptb(ji,jj,jk,jn) + p2dt(jk) * ze3tn * pta(ji,jj,jk,jn)   ! zrhs=right hand side 
+                  pta(ji,jj,jk,jn) = zrhs - zwi(ji,jj,jk) / zwt(ji,jj,jk-1) * pta(ji,jj,jk-1,jn)
+               END DO
+#else
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
@@ -209,6 +298,16 @@
             END DO
          END DO
+#endif
 
          ! third recurrence:    Xk = (Zk - Sk Xk+1 ) / Tk   (result is the after tracer)
+#if defined key_z_first
+               pta(ji,jj,jpkm1,jn) = pta(ji,jj,jpkm1,jn) / zwt(ji,jj,jpkm1) * tmask(ji,jj,jpkm1)
+               DO jk = jpk-2, 1, -1
+                  pta(ji,jj,jk,jn) = ( pta(ji,jj,jk,jn) - zws(ji,jj,jk) * pta(ji,jj,jk+1,jn) )   &
+                     &             / zwt(ji,jj,jk) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
@@ -224,4 +323,5 @@
             END DO
          END DO
+#endif
          !                                            ! ================= !
       END DO                                          !  end tracer loop  !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 3211)
@@ -26,4 +26,8 @@
 
    PUBLIC   zps_hde    ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -87,7 +91,16 @@
       INTEGER                              , INTENT(in   )           ::  kt          ! ocean time-step index
       INTEGER                              , INTENT(in   )           ::  kjpt        ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   )           ::  pta         ! 4D tracers fields
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   )           ::  pta         ! 4D tracers fields
+!FTRANS pta :I :I :z :
+      REAL(wp), INTENT(in   )                      ::  pta(jpi,jpj,jpk,kjpt)         ! 4D tracers fields
+
       REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT(  out)           ::  pgtu, pgtv  ! hor. grad. of ptra at u- & v-pts 
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ), OPTIONAL ::  prd         ! 3D density anomaly fields
+
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ), OPTIONAL ::  prd         ! 3D density anomaly fields
+!FTRANS prd :I :I :z
+      REAL(wp), INTENT(in   ), OPTIONAL            ::  prd(jpi,jpj,jpk)              ! 3D density anomaly fields
+
       REAL(wp), DIMENSION(jpi,jpj         ), INTENT(  out), OPTIONAL ::  pgru, pgrv  ! hor. grad. of prd at u- & v-pts 
       !
@@ -126,5 +139,9 @@
                   zti(ji,jj,jn) = pta(ji+1,jj,iku,jn) + zmaxu * ( pta(ji+1,jj,ikum1,jn) - pta(ji+1,jj,iku,jn) )
                   ! gradient of  tracers
+#if defined key_z_first
+                  pgtu(ji,jj,jn) = umask_1(ji,jj) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
+#else
                   pgtu(ji,jj,jn) = umask(ji,jj,1) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
+#endif
                ELSE                           ! case 2
                   zmaxu = -ze3wu / fse3w(ji,jj,iku)
@@ -132,5 +149,9 @@
                   zti(ji,jj,jn) = pta(ji,jj,iku,jn) + zmaxu * ( pta(ji,jj,ikum1,jn) - pta(ji,jj,iku,jn) )
                   ! gradient of tracers
+#if defined key_z_first
+                  pgtu(ji,jj,jn) = umask_1(ji,jj) * ( pta(ji+1,jj,iku,jn) - zti(ji,jj,jn) )
+#else
                   pgtu(ji,jj,jn) = umask(ji,jj,1) * ( pta(ji+1,jj,iku,jn) - zti(ji,jj,jn) )
+#endif
                ENDIF
                !
@@ -141,5 +162,9 @@
                   ztj(ji,jj,jn) = pta(ji,jj+1,ikv,jn) + zmaxv * ( pta(ji,jj+1,ikvm1,jn) - pta(ji,jj+1,ikv,jn) )
                   ! gradient of tracers
+#if defined key_z_first
+                  pgtv(ji,jj,jn) = vmask_1(ji,jj) * ( ztj(ji,jj,jn) - pta(ji,jj,ikv,jn) )
+#else
                   pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( ztj(ji,jj,jn) - pta(ji,jj,ikv,jn) )
+#endif
                ELSE                           ! case 2
                   zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
@@ -147,5 +172,9 @@
                   ztj(ji,jj,jn) = pta(ji,jj,ikv,jn) + zmaxv * ( pta(ji,jj,ikvm1,jn) - pta(ji,jj,ikv,jn) )
                   ! gradient of tracers
+#if defined key_z_first
+                  pgtv(ji,jj,jn) = vmask_1(ji,jj) * ( pta(ji,jj+1,ikv,jn) - ztj(ji,jj,jn) )
+#else
                   pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( pta(ji,jj+1,ikv,jn) - ztj(ji,jj,jn) )
+#endif
                ENDIF
 # if ! defined key_vectopt_loop
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 3211)
@@ -39,4 +39,12 @@
    PUBLIC   trd_icp_init  ! called by opa.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trdmld_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -121,6 +129,13 @@
       !!              momentum equations at every time step frequency nn_trd.
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dx   ! Temperature or U trend 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dy   ! Salinity    or V trend
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dx   ! Temperature or U trend 
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrd3dy   ! Salinity    or V trend
+
+!FTRANS ptrd3dx ptrd3dy :I :I :z
+      REAL(wp), INTENT(inout) ::   ptrd3dx(jpi,jpj,jpk)   ! Temperature or U trend 
+      REAL(wp), INTENT(inout) ::   ptrd3dy(jpi,jpj,jpk)   ! Salinity    or V trend
+
       INTEGER,                          INTENT(in   ) ::   ktrd      ! momentum or tracer trend index
       CHARACTER(len=3),                 INTENT(in   ) ::   ctype     ! momentum ('DYN') or tracers ('TRA') trends
@@ -132,7 +147,13 @@
       !
       CASE( 'DYN' )              ! Momentum        
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpjm1
                DO ji = 1, jpim1
+#endif
                   ptrd3dx(ji,jj,jk) = ptrd3dx(ji,jj,jk) * tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,jk)
                   ptrd3dy(ji,jj,jk) = ptrd3dy(ji,jj,jk) * tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)
@@ -144,8 +165,19 @@
          !
       CASE( 'TRA' )              ! Tracers
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  ptrd3dx(ji,jj,jk) = ptrd3dx(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
+                  ptrd3dy(ji,jj,jk) = ptrd3dy(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             ptrd3dx(:,:,jk) = ptrd3dx(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
             ptrd3dy(:,:,jk) = ptrd3dy(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
          END DO
+#endif
          !
       END SELECT   
@@ -156,16 +188,40 @@
          umo(ktrd) = 0._wp
          vmo(ktrd) = 0._wp
+#if defined key_z_first
+         !! DCSE_NEMO: this changes the order of summation
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  umo(ktrd) = umo(ktrd) + ptrd3dx(ji,jj,jk) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk)
+                  vmo(ktrd) = vmo(ktrd) + ptrd3dy(ji,jj,jk) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             umo(ktrd) = umo(ktrd) + SUM( ptrd3dx(:,:,jk) * e1u(:,:) * e2u(:,:) * fse3u(:,:,jk) )
             vmo(ktrd) = vmo(ktrd) + SUM( ptrd3dy(:,:,jk) * e1v(:,:) * e2v(:,:) * fse3v(:,:,jk) )
          END DO
+#endif
          !
       CASE( 'TRA' )              ! Tracers
          tmo(ktrd) = 0._wp
          smo(ktrd) = 0._wp
+#if defined key_z_first
+         !! DCSE_NEMO: this changes the order of summation
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  tmo(ktrd) = tmo(ktrd) + ptrd3dx(ji,jj,jk) * e1e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  smo(ktrd) = smo(ktrd) + ptrd3dy(ji,jj,jk) * e1e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             tmo(ktrd) = tmo(ktrd) + SUM( ptrd3dx(:,:,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
             smo(ktrd) = smo(ktrd) + SUM( ptrd3dy(:,:,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
          END DO
+#endif
          !
       END SELECT
@@ -175,16 +231,43 @@
       CASE( 'DYN' )              ! Momentum
          hke(ktrd) = 0._wp
+#if defined key_z_first
+         !! DCSE_NEMO: this changes the order of summation
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  hke(ktrd) = hke(ktrd) + un(ji,jj,jk) * ptrd3dx(ji,jj,jk) * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk)   &
+                     &                  + vn(ji,jj,jk) * ptrd3dy(ji,jj,jk) * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk)  
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             hke(ktrd) = hke(ktrd) + SUM(   un(:,:,jk) * ptrd3dx(:,:,jk) * e1u(:,:) * e2u(:,:) * fse3u(:,:,jk)   &
                &                         + vn(:,:,jk) * ptrd3dy(:,:,jk) * e1v(:,:) * e2v(:,:) * fse3v(:,:,jk)   )
          END DO
+#endif
          !
       CASE( 'TRA' )              ! Tracers
          t2(ktrd) = 0._wp
          s2(ktrd) = 0._wp
+#if defined key_z_first
+         !! DCSE_NEMO: this changes the order of summation
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  t2(ktrd) = t2(ktrd) + ptrd3dx(ji,jj,jk) * tn(ji,jj,jk) * e1e2t(ji,jj) * fse3t(ji,jj,jk)
+                  s2(ktrd) = s2(ktrd) + ptrd3dy(ji,jj,jk) * sn(ji,jj,jk) * e1e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
-            t2(ktrd) = t2(ktrd) + SUM( ptrd3dx(ji,jj,jk) * tn(ji,jj,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
-            s2(ktrd) = s2(ktrd) + SUM( ptrd3dy(ji,jj,jk) * sn(ji,jj,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
-         END DO
+         !! DCSE_NEMO: This looks plain wrong!
+!           t2(ktrd) = t2(ktrd) + SUM( ptrd3dx(ji,jj,jk) * tn(ji,jj,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
+!           s2(ktrd) = s2(ktrd) + SUM( ptrd3dy(ji,jj,jk) * sn(ji,jj,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
+            t2(ktrd) = t2(ktrd) + SUM( ptrd3dx(:,:,jk) * tn(:,:,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
+            s2(ktrd) = s2(ktrd) + SUM( ptrd3dy(:,:,jk) * sn(:,:,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
+         END DO
+#endif
          !
       END SELECT
@@ -210,7 +293,19 @@
       ! Total volume at t-points:
       tvolt = 0._wp
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+               tvolt = tvolt + e1e2t(ji,jj) * fse3t(ji,jj,jk) * tmask(ji,jj,jk) * tmask_i(ji,jj)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpkm1
-         tvolt = SUM( e1e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:) )
+      !! DCSE_NEMO: This looks plain wrong
+!        tvolt = SUM( e1e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:) )
+         tvolt = tvolt + SUM( e1e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:) )
       END DO
+#endif
       IF( lk_mpp )   CALL mpp_sum( tvolt )   ! sum over the global domain
 
@@ -225,7 +320,13 @@
       tvolv = 0._wp
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                tvolu = tvolu + e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk) * tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,jk)
                tvolv = tvolv + e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk) * tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)
@@ -254,4 +355,8 @@
       USE wrk_nemo, ONLY:   zkepe => wrk_3d_1 , zkx => wrk_3d_2   ! 3D workspace
       USE wrk_nemo, ONLY:   zky   => wrk_3d_3 , zkz => wrk_3d_4   !  -      -
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zkepe zkx zky zkz :I :I :z
+
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -281,13 +386,30 @@
 
          zcof = 0.5_wp / rau0             ! Density flux at w-point
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zkz(ji,jj,1) = 0._wp
+               DO jk = 2, jpk
+                  zkz(ji,jj,jk) = e1e2t(ji,jj) * wn(ji,jj,jk) * ( rhop(ji,jj,jk) + rhop(ji,jj,jk-1) ) * tmask_i(ji,jj)
+               END DO
+            END DO
+         END DO
+#else
          zkz(:,:,1) = 0._wp
          DO jk = 2, jpk
             zkz(:,:,jk) = e1e2t(:,:) * wn(:,:,jk) * ( rhop(:,:,jk) + rhop(:,:,jk-1) ) * tmask_i(:,:)
          END DO
+#endif
          
          zcof   = 0.5_wp / rau0           ! Density flux at u and v-points
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpjm1
                DO ji = 1, jpim1
+#endif
                   zkx(ji,jj,jk) = zcof * e2u(ji,jj) * fse3u(ji,jj,jk) * un(ji,jj,jk) * ( rhop(ji,jj,jk) + rhop(ji+1,jj,jk) )
                   zky(ji,jj,jk) = zcof * e1v(ji,jj) * fse3v(ji,jj,jk) * vn(ji,jj,jk) * ( rhop(ji,jj,jk) + rhop(ji,jj+1,jk) )
@@ -296,7 +418,13 @@
          END DO
          
+#if defined key_z_first
+         DO jj = 2, jpjm1                 ! Density flux divergence at t-point
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                 ! Density flux divergence at t-point
             DO jj = 2, jpjm1
                DO ji = 2, jpim1
+#endif
                   zkepe(ji,jj,jk) = - (  zkz(ji,jj,jk) - zkz(ji  ,jj  ,jk+1)               &
                      &                 + zkx(ji,jj,jk) - zkx(ji-1,jj  ,jk  )               &
@@ -310,7 +438,17 @@
          ! ----------------------------------------
          peke = 0._wp
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  peke = peke + zkepe(ji,jj,jk) * fsdept(ji,jj,jk) * e1e2t(ji,jj) * fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             peke = peke + SUM( zkepe(:,:,jk) * fsdept(:,:,jk) * e1e2t(:,:) * fse3t(:,:,jk) )
          END DO
+#endif
          peke = grav * peke
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 3211)
@@ -53,4 +53,13 @@
    INTEGER ::   ionce, icount                   
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trdmld_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -98,6 +107,12 @@
       INTEGER                         , INTENT( in ) ::   ktrd       ! ocean trend index
       CHARACTER(len=2)                , INTENT( in ) ::   ctype      ! 2D surface/bottom or 3D interior physics
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   pttrdmld   ! temperature trend 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   pstrdmld   ! salinity trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   pttrdmld   ! temperature trend 
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   pstrdmld   ! salinity trend 
+
+!FTRANS pttrdmld pstrdmld :I :I :z
+      REAL(wp), INTENT( in ) ::   pttrdmld(jpi,jpj,jpk)   ! temperature trend 
+      REAL(wp), INTENT( in ) ::   pstrdmld(jpi,jpj,jpk)   ! salinity trend 
       !
       INTEGER ::   ji, jj, jk, isum
@@ -160,8 +175,15 @@
          ! ... Weights for vertical averaging
          wkx(:,:,:) = 0.e0
+#if defined key_z_first
+         DO jj = 1,jpj                 ! initialize wkx with vertical scale factor in mixed-layer
+            DO ji = 1,jpi
+               DO jk = 1, jpktrd
+                  IF( jk < nmld(ji,jj) )          wkx(ji,jj,jk) = fse3t(ji,jj,jk) * tmask(ji,jj,jk)
+#else
          DO jk = 1, jpktrd             ! initialize wkx with vertical scale factor in mixed-layer
             DO jj = 1,jpj
                DO ji = 1,jpi
                   IF( jk - nmld(ji,jj) < 0.e0 )   wkx(ji,jj,jk) = fse3t(ji,jj,jk) * tmask(ji,jj,jk)
+#endif
                END DO
             END DO
@@ -169,11 +191,31 @@
          
          rmld(:,:) = 0.e0                ! compute mixed-layer depth : rmld
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpktrd
+                  rmld(ji,jj) = rmld(ji,jj) + wkx(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpktrd
             rmld(:,:) = rmld(:,:) + wkx(:,:,jk)
          END DO
-         
+#endif
+         
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpktrd             ! compute integration weights
+                  wkx(ji,jj,jk) = wkx(ji,jj,jk) / MAX( 1., rmld(ji,jj) )
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpktrd             ! compute integration weights
             wkx(:,:,jk) = wkx(:,:,jk) / MAX( 1., rmld(:,:) )
          END DO
+#endif
 
          icount = 0                    ! <<< flag = off : control surface & integr. weights
@@ -186,8 +228,19 @@
       SELECT CASE (ctype)
       CASE ( '3D' )   ! mean T/S trends in the mixed-layer
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpktrd
+                  tmltrd(ji,jj,ktrd) = tmltrd(ji,jj,ktrd) + pttrdmld(ji,jj,jk) * wkx(ji,jj,jk)   ! temperature
+                  smltrd(ji,jj,ktrd) = smltrd(ji,jj,ktrd) + pstrdmld(ji,jj,jk) * wkx(ji,jj,jk)   ! salinity
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpktrd
             tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,jk) * wkx(:,:,jk)   ! temperature
             smltrd(:,:,ktrd) = smltrd(:,:,ktrd) + pstrdmld(:,:,jk) * wkx(:,:,jk)   ! salinity
          END DO
+#endif
       CASE ( '2D' )   ! forcing at upper boundary of the mixed-layer
          tmltrd(:,:,ktrd) = tmltrd(:,:,ktrd) + pttrdmld(:,:,1) * wkx(:,:,1)        ! non penetrative
@@ -198,5 +251,15 @@
       !
    END SUBROUTINE trd_mld_zint
-    
+
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trdmld_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
 
    SUBROUTINE trd_mld( kt )
@@ -261,5 +324,11 @@
       LOGICAL :: lldebug = .TRUE.
       REAL(wp) :: zavt, zfn, zfn2
+
+#if defined key_z_first
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztmltrd2, zsmltrd2   ! only needed for mean diagnostics
+#else
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztmltrd2, zsmltrd2   ! only needed for mean diagnostics
+#endif
+
 #if defined key_dimgout
       INTEGER ::  iyear,imon,iday
@@ -269,4 +338,11 @@
       
       ! Check that the workspace arrays are all OK to be used
+#if defined key_z_first
+      IF( wrk_in_use(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14) ) THEN
+         CALL ctl_stop('trd_mld : requested workspace arrays unavailable')   ;   RETURN
+      END IF
+      ALLOCATE( ztmltrd2(jpi,jpj,jpltrd) )
+      ALLOCATE( zsmltrd2(jpi,jpj,jpltrd) )
+#else
       IF( wrk_in_use(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14)  .OR. &
           wrk_in_use(3, 1,2)                                 ) THEN
@@ -280,4 +356,5 @@
       ztmltrd2 => wrk_3d_1(1:,:,1:jpltrd)
       zsmltrd2 => wrk_3d_2(1:,:,1:jpltrd)
+#endif
 
       ! ======================================================================
@@ -333,8 +410,19 @@
       ! --------------------------------
       tml(:,:) = 0.e0   ;   sml(:,:) = 0.e0
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpktrd - 1
+               tml(ji,jj) = tml(ji,jj) + wkx(ji,jj,jk) * tn(ji,jj,jk)
+               sml(ji,jj) = sml(ji,jj) + wkx(ji,jj,jk) * sn(ji,jj,jk) 
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpktrd - 1
          tml(:,:) = tml(:,:) + wkx(:,:,jk) * tn(:,:,jk)
          sml(:,:) = sml(:,:) + wkx(:,:,jk) * sn(:,:,jk) 
       END DO
+#endif
 
       ! II.3 Initialize mixed-layer "before" arrays for the 1rst analysis window    
@@ -740,7 +828,13 @@
       IF( lrst_oce )   CALL trd_mld_rst_write( kt ) 
 
+#if defined key_z_first
+      IF( wrk_not_released(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14) )   &
+          CALL ctl_stop('trd_mld : failed to release workspace arrays.')
+      DEALLOCATE( ztmltrd2, zsmltrd2 )
+#else
       IF( wrk_not_released(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14)  .OR. &
           wrk_not_released(3, 1,2)                                )   &
           CALL ctl_stop('trd_mld : failed to release workspace arrays.')
+#endif
       !
    END SUBROUTINE trd_mld
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 3211)
@@ -79,4 +79,8 @@
       smltrd_csum_ln,               & !:    ( idem for salinity )
       smltrd_csum_ub                  !: 
+
+   !! * Control permutation of array indices
+#  include "trdmld_oce_ftrans.h90"
+
 #endif
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce_ftrans.h90	(revision 3211)
@@ -0,0 +1,20 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  trdmld_oce_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   trdmld_oce.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS wkx :I :I :z
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 3211)
@@ -21,4 +21,7 @@
   
    INTEGER ::   nummldw         ! logical unit for mld restart
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!---------------------------------------------------------------------------------
